xn::MapGenerator Class Reference
C++ Reference to Application Programmer Interface (API) » Production Nodes Functionality

`#include <XnCppWrapper.h>`

Inheritance diagram for xn::MapGenerator:
[legend]

## Public Member Functions

| MapGenerator (XnNodeHandle hNode=NULL)
| MapGenerator (const NodeWrapper &other)
XnUInt32 | GetSupportedMapOutputModesCount () const
XnStatus | GetSupportedMapOutputModes (XnMapOutputMode *aModes, XnUInt32 &nCount) const
XnStatus | SetMapOutputMode (const XnMapOutputMode &OutputMode)
XnStatus | GetMapOutputMode (XnMapOutputMode &OutputMode) const
XnUInt32 | GetBytesPerPixel () const
XnStatus | RegisterToMapOutputModeChange (StateChangedHandler handler, void *pCookie, XnCallbackHandle &hCallback)
void | UnregisterFromMapOutputModeChange (XnCallbackHandle hCallback)
const CroppingCapability | GetCroppingCap () const
CroppingCapability | GetCroppingCap ()
GeneralIntCapability | GetBrightnessCap ()
GeneralIntCapability | GetContrastCap ()
GeneralIntCapability | GetHueCap ()
GeneralIntCapability | GetSaturationCap ()
GeneralIntCapability | GetSharpnessCap ()
GeneralIntCapability | GetGammaCap ()
GeneralIntCapability | GetWhiteBalanceCap ()
GeneralIntCapability | GetBacklightCompensationCap ()
GeneralIntCapability | GetGainCap ()
GeneralIntCapability | GetPanCap ()
GeneralIntCapability | GetTiltCap ()
GeneralIntCapability | GetRollCap ()
GeneralIntCapability | GetZoomCap ()
GeneralIntCapability | GetExposureCap ()
GeneralIntCapability | GetIrisCap ()
GeneralIntCapability | GetFocusCap ()
GeneralIntCapability | GetLowLightCompensationCap ()
AntiFlickerCapability | GetAntiFlickerCap ()
Public Member Functions inherited from xn::Generator
| Generator (XnNodeHandle hNode=NULL)
| Generator (const NodeWrapper &other)
XnStatus | StartGenerating ()
XnBool | IsGenerating () const
XnStatus | StopGenerating ()
XnStatus | RegisterToGenerationRunningChange (StateChangedHandler handler, void *pCookie, XnCallbackHandle &hCallback)
void | UnregisterFromGenerationRunningChange (XnCallbackHandle hCallback)
XnStatus | RegisterToNewDataAvailable (StateChangedHandler handler, void *pCookie, XnCallbackHandle &hCallback)
void | UnregisterFromNewDataAvailable (XnCallbackHandle hCallback)
XnBool | IsNewDataAvailable (XnUInt64 *pnTimestamp=NULL) const
XnStatus | WaitAndUpdateData ()
XnBool | IsDataNew () const
const void * | GetData ()
XnUInt32 | GetDataSize () const
XnUInt64 | GetTimestamp () const
XnUInt32 | GetFrameID () const
const MirrorCapability | GetMirrorCap () const
MirrorCapability | GetMirrorCap ()
const AlternativeViewPointCapability | GetAlternativeViewPointCap () const
AlternativeViewPointCapability | GetAlternativeViewPointCap ()
const FrameSyncCapability | GetFrameSyncCap () const
FrameSyncCapability | GetFrameSyncCap ()
Public Member Functions inherited from xn::ProductionNode
| ProductionNode (XnNodeHandle hNode=NULL)
| ProductionNode (const NodeWrapper &other)
NodeInfo | GetInfo () const
XnStatus | AddNeededNode (ProductionNode &needed)
XnStatus | RemoveNeededNode (ProductionNode &needed)
void | GetContext (Context &context) const
Context | GetContext () const
XnBool | IsCapabilitySupported (const XnChar *strCapabilityName) const
XnStatus | SetIntProperty (const XnChar *strName, XnUInt64 nValue)
XnStatus | SetRealProperty (const XnChar *strName, XnDouble dValue)
XnStatus | SetStringProperty (const XnChar *strName, const XnChar *strValue)
XnStatus | SetGeneralProperty (const XnChar *strName, XnUInt32 nBufferSize, const void *pBuffer)
XnStatus | GetIntProperty (const XnChar *strName, XnUInt64 &nValue) const
XnStatus | GetRealProperty (const XnChar *strName, XnDouble &dValue) const
XnStatus | GetStringProperty (const XnChar *strName, XnChar *csValue, XnUInt32 nBufSize) const
XnStatus | GetGeneralProperty (const XnChar *strName, XnUInt32 nBufferSize, void *pBuffer) const
XnStatus | LockForChanges (XnLockHandle *phLock)
void | UnlockForChanges (XnLockHandle hLock)
XnStatus | LockedNodeStartChanges (XnLockHandle hLock)
void | LockedNodeEndChanges (XnLockHandle hLock)
const ErrorStateCapability | GetErrorStateCap () const
ErrorStateCapability | GetErrorStateCap ()
GeneralIntCapability | GetGeneralIntCap (const XnChar *strCapability)
Public Member Functions inherited from xn::NodeWrapper
| NodeWrapper (XnNodeHandle hNode)
| NodeWrapper (const NodeWrapper &other)
NodeWrapper & | operator= (const NodeWrapper &other)
| ~NodeWrapper ()
| operator XnNodeHandle () const
XnNodeHandle | GetHandle () const
XnBool | operator== (const NodeWrapper &other)
XnBool | operator!= (const NodeWrapper &other)
XnBool | IsValid () const
const XnChar * | GetName () const
XnStatus | AddRef ()
void | Release ()
void | SetHandle (XnNodeHandle hNode)
void | TakeOwnership (XnNodeHandle hNode)

## Detailed Description

Purpose: The MapGenerator class is the base class for every generator node that produces 2D map data, for example, depth maps, color image maps, IR maps, and scene analysis maps.

Usage: This class might be instantiated to reference any kind of map generator node (i.e., a node that derives from the MapGenerator class), however it is not intended to ever be instantiated to create any node of MapGenerator type itself.

Remarks:

Since the MapGenerator class is the base class for generator nodes that produce image maps, it provides the data structures common to all map generators: the current frame's X and Y dimensions and its frame rate.

MapGenerator's two principle functions are GetMapOutputMode() and SetMapOutputMode() for controlling and checking the node's map output mode. The map output mode is the combination of the node's scene resolution and frame rate. Correspondingly, these functions read and write an xn::XnMapOutputMode structure, comprising three parameters: the X and Y resolutions and the frame rate.

## Constructor & Destructor Documentation

## MapGenerator() [1/2]

xn::MapGenerator::MapGenerator | ( | XnNodeHandle | hNode = NULL | ) |

inline

Ctor

Parameters

  [in] | hNode | Node handle

## MapGenerator() [2/2]

xn::MapGenerator::MapGenerator | ( | const NodeWrapper & | other | ) |

inline

## Member Function Documentation

## GetAntiFlickerCap()

AntiFlickerCapability xn::MapGenerator::GetAntiFlickerCap | ( |  | ) |

inline

Gets an AntiFlickerCapability object for accessing Anti Flicker functionality. It is the application responsibility to check first if XN_CAPABILITY_ANTI_FLICKER is supported by calling IsCapabilitySupported().

## GetBacklightCompensationCap()

GeneralIntCapability xn::MapGenerator::GetBacklightCompensationCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing BacklightCompensation functionality. It is the application responsibility to check first if XN_CAPABILITY_BACKLIGHT_COMPENSATION is supported by calling IsCapabilitySupported().

## GetBrightnessCap()

GeneralIntCapability xn::MapGenerator::GetBrightnessCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Brightness functionality. It is the application responsibility to check first if XN_CAPABILITY_BRIGHTNESS is supported by calling IsCapabilitySupported().

## GetBytesPerPixel()

XnUInt32 xn::MapGenerator::GetBytesPerPixel | ( |  | ) | const

inline

Gets the number of bytes per pixel for the node's map data. This mode is set by SetPixelFormat() for the next frame that the generator node generates.

Remarks

In ImageGenerator this can be set. In other generators, it's pre-defined.

## GetContrastCap()

GeneralIntCapability xn::MapGenerator::GetContrastCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Contrast functionality. It is the application responsibility to check first if XN_CAPABILITY_CONTRAST is supported by calling IsCapabilitySupported().

## GetCroppingCap() [1/2]

CroppingCapability xn::MapGenerator::GetCroppingCap | ( |  | ) |

inline

Gets a CroppingCapability object for accessing Cropping functionality.

Remarks

It is the application's responsibility to check first if XN_CAPABILITY_CROPPING is supported by calling IsCapabilitySupported().

## GetCroppingCap() [2/2]

const CroppingCapability xn::MapGenerator::GetCroppingCap | ( |  | ) | const

inline

Gets a CroppingCapability object for accessing Cropping functionality.

Remarks

It is the application's responsibility to check first if XN_CAPABILITY_CROPPING is supported by calling IsCapabilitySupported().

## GetExposureCap()

GeneralIntCapability xn::MapGenerator::GetExposureCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Exposure functionality. It is the application responsibility to check first if XN_CAPABILITY_EXPOSURE is supported by calling IsCapabilitySupported().

## GetFocusCap()

GeneralIntCapability xn::MapGenerator::GetFocusCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Focus functionality. It is the application responsibility to check first if XN_CAPABILITY_FOCUS is supported by calling IsCapabilitySupported().

## GetGainCap()

GeneralIntCapability xn::MapGenerator::GetGainCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Gain functionality. It is the application responsibility to check first if XN_CAPABILITY_GAIN is supported by calling IsCapabilitySupported().

## GetGammaCap()

GeneralIntCapability xn::MapGenerator::GetGammaCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Gamma functionality. It is the application responsibility to check first if XN_CAPABILITY_GAMMA is supported by calling IsCapabilitySupported().

## GetHueCap()

GeneralIntCapability xn::MapGenerator::GetHueCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Hue functionality. It is the application responsibility to check first if XN_CAPABILITY_HUE is supported by calling IsCapabilitySupported().

## GetIrisCap()

GeneralIntCapability xn::MapGenerator::GetIrisCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Iris functionality. It is the application responsibility to check first if XN_CAPABILITY_IRIS is supported by calling IsCapabilitySupported().

## GetLowLightCompensationCap()

GeneralIntCapability xn::MapGenerator::GetLowLightCompensationCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Low Light Compensation functionality. It is the application responsibility to check first if XN_CAPABILITY_LOW_LIGHT_COMPENSATION is supported by calling IsCapabilitySupported().

## GetMapOutputMode()

XnStatus xn::MapGenerator::GetMapOutputMode | ( | XnMapOutputMode & | OutputMode | ) | const

inline

Gets the current map output mode of the generator node. This is the map output mode that the generator node will use to generate the next data frame.

Remarks

A map output mode is the combination of the scene resolution and frame rate. It is contained in an xn::XnMapOutputMode structure comprising the frame rate (in frames per second), and the X and Y dimensions (the number of elements in each of the X- and Y- axes).

For the map output mode of the most recent data frame available in the node's metadata object, see the xn::MapMetaData class (MapMetaData::Xres(), MapMetaData::YRes(), and MapMetaData::FPS() methods).

This map output mode is the mode set by SetMapOutputMode().

## GetPanCap()

GeneralIntCapability xn::MapGenerator::GetPanCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Pan functionality. It is the application responsibility to check first if XN_CAPABILITY_PAN is supported by calling IsCapabilitySupported().

## GetRollCap()

GeneralIntCapability xn::MapGenerator::GetRollCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Roll functionality. It is the application responsibility to check first if XN_CAPABILITY_ROLL is supported by calling IsCapabilitySupported().

## GetSaturationCap()

GeneralIntCapability xn::MapGenerator::GetSaturationCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Saturation functionality. It is the application responsibility to check first if XN_CAPABILITY_SATURATION is supported by calling IsCapabilitySupported().

## GetSharpnessCap()

GeneralIntCapability xn::MapGenerator::GetSharpnessCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Sharpness functionality. It is the application responsibility to check first if XN_CAPABILITY_SHARPNESS is supported by calling IsCapabilitySupported().

## GetSupportedMapOutputModes()

XnStatus xn::MapGenerator::GetSupportedMapOutputModes | ( | XnMapOutputMode * | aModes,
|  | XnUInt32 & | nCount ) const

inline

Gets a list of all the output modes that the generator node supports.

Remarks

Each supported map output mode is represented by a XnMapOutputMode structure comprising resolution (`nXRes` and `nYRes`) and frames rate (`nFPS`). The application then chooses one of the output modes. The size of the array that should be passed can be obtained by calling GetSupportedMapOutputModesCount().

## GetSupportedMapOutputModesCount()

XnUInt32 xn::MapGenerator::GetSupportedMapOutputModesCount | ( |  | ) | const

inline

Gets the number of output modes that the generator node supports.

Remarks

This is useful for allocating an array that will be passed to GetSupportedMapOutputModes().

## GetTiltCap()

GeneralIntCapability xn::MapGenerator::GetTiltCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Tilt functionality. It is the application responsibility to check first if XN_CAPABILITY_TILT is supported by calling IsCapabilitySupported().

## GetWhiteBalanceCap()

GeneralIntCapability xn::MapGenerator::GetWhiteBalanceCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing WhiteBalance functionality. It is the application responsibility to check first if XN_CAPABILITY_COLOR_TEMPERATURE is supported by calling IsCapabilitySupported().

## GetZoomCap()

GeneralIntCapability xn::MapGenerator::GetZoomCap | ( |  | ) |

inline

Gets an GeneralIntCapability object for accessing Zoom functionality. It is the application responsibility to check first if XN_CAPABILITY_ZOOM is supported by calling IsCapabilitySupported().

## RegisterToMapOutputModeChange()

XnStatus xn::MapGenerator::RegisterToMapOutputModeChange | ( | StateChangedHandler | handler,
|  | void * | pCookie,
|  | XnCallbackHandle & | hCallback )

inline

Registers an event handler for the 'Map Output Mode Change' event.

Parameters

  [in] | handler | Callback function to be invoked when the event is raised.
  [in] | pCookie | User's cookie, to be delivered to the callback.
  [out] | hCallback | Handle to the callback to be used for unregistering it.

For full details and usage of the parameters, see Registering to Events.

## SetMapOutputMode()

XnStatus xn::MapGenerator::SetMapOutputMode | ( | const XnMapOutputMode & | OutputMode | ) |

inline

Sets the current map output mode of the generator node.

Remarks

A map output mode is contained in a xn::XnMapOutputMode structure comprising the frame rate (in frames per second), and the X and Y dimensions (the number of elements in each of the X- and Y- axes).

It is the application programmer's responsibility to check first if the output mode is supported by calling the GetSupportedMapOutputModes() method.

## UnregisterFromMapOutputModeChange()

void xn::MapGenerator::UnregisterFromMapOutputModeChange | ( | XnCallbackHandle | hCallback | ) |

inline

Unregisters the event handler for the 'Map Output Mode Change' event.

Parameters

  [in] | hCallback | Handle received from registration.

For full details and usage of the parameter, see Unregistering from Events .

The documentation for this class was generated from the following file:

- XnCppWrapper.h